
//Test Command String = ~+0000,+0000,+0000,+0000
//                        M1    M2    M3    LACT

char targetCommandString[] = {' ',' ',' ',' ',' '};
int target_Motor1_Command = 0;
int target_Motor2_Command = 0;
int target_FlipperMotor_Command = 0;
int target_LACT_Command = 0;



//----- IR BLOCK -----
#include <SharpIR.h>

#define IR_FRONT_LEFT         A5
#define IR_FRONT_RIGHT        A4
#define IR_LEFT               A3
#define IR_RIGHT              A2
#define IR_BACK_LEFT          A1
#define IR_BACK_RIGHT         A0

#define LONG_RANGE_IR_SENSOR  20150
#define MED_RANGE_IR_SENSOR   1080

SharpIR IR_FL(IR_FRONT_LEFT, LONG_RANGE_IR_SENSOR);
SharpIR IR_FR(IR_FRONT_RIGHT, LONG_RANGE_IR_SENSOR);
SharpIR IR_L(IR_LEFT, LONG_RANGE_IR_SENSOR);
SharpIR IR_R(IR_RIGHT, LONG_RANGE_IR_SENSOR);
SharpIR IR_BL(IR_BACK_LEFT, LONG_RANGE_IR_SENSOR);
SharpIR IR_BR(IR_BACK_RIGHT, LONG_RANGE_IR_SENSOR);
//--------------------


void setup() {
  // put your setup code here, to run once:
  Serial.begin( 250000 );
  //---- IR BLOCK SETUP ----
  pinMode( IR_FRONT_LEFT, INPUT);
  pinMode( IR_FRONT_RIGHT, INPUT);
  pinMode( IR_LEFT, INPUT);
  pinMode( IR_RIGHT, INPUT);
  pinMode( IR_BACK_LEFT, INPUT);
  pinMode( IR_BACK_RIGHT, INPUT);
  //------------------------
}

void loop() {
  // put your main code here, to run repeatedly:
    if(Serial.available() > 0 && irReadOut()) {
 
      Serial.print("Parsing Serial\n");
  
      byte b =  Serial.read();
      
      if (b == 126)
      {
        char charIn = 0;
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();
  
        target_Motor1_Command = atoi(targetCommandString);
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();
  
        target_Motor2_Command = atoi(targetCommandString);
        
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();
  
        target_FlipperMotor_Command = atoi(targetCommandString);
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();
  
        target_LACT_Command = atoi(targetCommandString);
  
  
        Serial.println("--------- NEW TARGET Motor Values -----------");
        Serial.print("target_Motor1_Command: ");
        Serial.println(target_Motor1_Command);
        Serial.print("target_Motor2_Command: ");
        Serial.println(target_Motor2_Command);      
        Serial.print("target_FlipperMotor_Command: ");
        Serial.println(target_FlipperMotor_Command);      
        Serial.print("target_LACT_Command: ");
        Serial.println(target_LACT_Command);      
        Serial.println("---------------------------------------");
        
        //irReadOut();
        
        Serial.println("---------------------------------------");
        
      }
   }
}


int irReadOut()
{
  /* Check for obstacles */
  Serial.print( "( " );
  Serial.print( IR_FL.distance() );
  Serial.print( ", " );
  Serial.print( IR_FR.distance() );
  Serial.print( ", " );
  Serial.print( IR_L.distance() );
  Serial.print( ", " );
  Serial.print( IR_R.distance() );
  Serial.print( ", " );
  Serial.print( IR_BL.distance() );
  Serial.print( ", " );
  Serial.print( IR_BR.distance() );
  Serial.print( ")\n" );


  /* Avoid reading before the new distance is sampled */
  delay( 100 );
  return 1;
}
